<?php
/*
 * @Author: wang jun
 * @Date: 2022-01-18 11:12:23
 * @Last Modified by: wang jun
 * @Last Modified time: 2022-01-19 17:24:07
 * 微信类
 */
namespace app\index\logic;

use app\index\model\companymodel;
use app\index\model\partymodel;
use app\index\model\partyrecordmodel;

class partylogic extends baselogic
{
    /**
     * 设置请求数据规则
     * 20220107
     * wj
     */
    protected function setrules()
    {
        $list = [
            'getinfobytime' => [
                ['name' => 'time', 'title' => 'openid', 'require' => true, 'type' => 'string'],
            ],
            'getinfobyid' => [
                ['name' => 'id', 'title' => 'id', 'require' => true, 'type' => 'numeric'],
            ],
            'companysingup' => [
                ['name' => 'partyid', 'title' => 'partyid', 'require' => true, 'type' => 'numeric'],
                ['name' => 'companyid', 'title' => 'companyid', 'require' => true, 'type' => 'numeric'],
            ],
            'getlistbywhere' => [
                ['name' => 'partyid', 'title' => 'partyid', 'require' => true, 'type' => 'numeric'],
            ],
        ];
        return $list;
    }
    /**
     * 根据时间获取信息
     * 20220119
     * wj
     */
    public function getinfobytime($arr)
    {
        $result = $this->checkparam(__FUNCTION__, $arr);
        if (1 != $result['status']) {
            return $result;
        }
        $time = $arr['time'];
        $m_p = new partymodel();
        $info = $m_p->getinfobytime($time);
        if (empty($info)) {
            return backarr(0, "无数据");
        }
        return backarr(1, "获取成功", $info);
    }
    /**
     * 根据id获取信息
     * 20220119
     * wj
     */
    public function getinfobyid($arr)
    {
        $result = $this->checkparam(__FUNCTION__, $arr);
        if (1 != $result['status']) {
            return $result;
        }
        $id = $arr['id'];
        $m_i = new partymodel();
        $info = $m_i->getinfobyid($id);
        if (empty($row)) {
            return backarr(0, "无数据");
        }
        return backarr(1, "获取成功", $info);
    }
    /**
     * 企业报名
     * 20220119
     * wj
     */
    public function companysingup($arr)
    {
        $result = $this->checkparam(__FUNCTION__, $arr);
        if (1 != $result['status']) {
            return $result;
        }
        $companyid = $arr['companyid'];
        $partyid = $arr['partyid'];
        $m_c = new companymodel();
        $cinfo = $m_c->getinfobyid($companyid);
        if (empty($cinfo)) {
            return backarr(0, "企业信息不存在");
        }
        $m_p = new partymodel();
        $pinfo = $m_p->getinfobyid($partyid);
        if (empty($pinfo)) {
            return backarr(0, "活动信息不存在");
        }
        $m_pr = new partyrecordmodel();
        $where = [
            'party_id' => $pinfo['id'],
            'company_id' => $cinfo['id'],
        ];
        $pfinfo = $m_pr->getInfo($where, ['id']);
        if (!empty($pfinfo)) {
            return backarr(0, "企业已报名");
        }
        $arr['party_id'] = $pinfo['id'];
        $arr['company_id'] = $cinfo['id'];
        $id = $m_pr->insertData($arr);
        if (empty($id)) {
            return backarr(0, "报名失败");
        }
        return backarr(1, "报名成功", ['id' => $id]);
    }
    /**
     * 获取列表
     * 20220119
     * wj
     */
    public function getlistcompanybypartyid($arr)
    {
        $result = $this->checkparam(__FUNCTION__, $arr);
        if (1 != $result['status']) {
            return $result;
        }
        $partyid = $arr['partyid'];
        $m_p = new partymodel();
        $pinfo = $m_p->getinfobyid($partyid);
        if (empty($pinfo)) {
            return backarr(0, "活动信息不存在");
        }
        $where = ['party_id' => $partyid];
        $page = isset($arr['page']) && !empty($arr['page']) ? $arr['page'] : 1;
        $size = isset($arr['size']) && !empty($arr['size']) ? $arr['size'] : 10;
        $m_pr = new partyrecordmodel();
        $count = $m_pr->getList($where, 'count');
        if ($count <= 0) {
            return backarr(0, "无数据");
        }
        $list = $m_pr->getList($where, '*', $page, $size);
        return backarr(1, "查询成功", $list);
    }
}
